﻿using System.ComponentModel;
using System.Reflection;
using System.Windows;
using PropertyGrid.ViewModel;

namespace PropertyGrid.Generator
{
    using Infragistics.Controls.Editors;
    using System.Collections.Generic;

    /// <summary>
    /// 
    /// </summary>
    /// <seealso cref="Infragistics.Controls.Editors.TypeDescriptorPropertyGenerator" />
    public class CustomGenerator: TypeDescriptorPropertyGenerator
    {
        /// <summary>
        /// The _property descriptor
        /// </summary>
        private readonly FieldInfo _propertyDescriptor;

        /// <summary>
        /// The _source object
        /// </summary>
        private readonly FieldInfo _sourceObject;

        /// <summary>
        /// The _property name
        /// </summary>
        private readonly PropertyInfo _propertyName;

        private readonly PropertyInfo _pathName;
        /// <summary>
        /// Initializes a new instance of the <see cref="CustomGenerator"/> class.
        /// </summary>
        public CustomGenerator()
        {
            _propertyDescriptor = typeof(PropertyGridPropertyItem).GetField("_propertyDescriptor", BindingFlags.NonPublic | BindingFlags.Instance);
            _sourceObject = typeof(PropertyGridPropertyItem).GetField("_sourceObject", BindingFlags.NonPublic | BindingFlags.Instance);
            _propertyName = typeof(PropertyGridPropertyItem).GetProperty("PropertyName", BindingFlags.Public | BindingFlags.Instance);
            _pathName = typeof (PropertyGridPropertyItem).GetProperty("PropertyPathForBinding",
                BindingFlags.NonPublic | BindingFlags.Instance);
        }

        /// <summary>
        /// Generates <see cref="T:Infragistics.Controls.Editors.PropertyGridPropertyItem" />s for the specified object while honoring the specified <see cref="T:Infragistics.Controls.Editors.PropertyGenerationOptions" /> as well as
        /// the filters defined in the <see cref="P:Infragistics.Controls.Editors.PropertyGeneratorBase.GeneratedPropertyFilter" /> property (if any).  This method must be overridden by derived generator classes.
        /// </summary>
        /// <param name="forObject">The object whose properties should be inspected.</param>
        /// <param name="generationOptions">The options to honor when generating properties.</param>
        /// <param name="forPropertyItem">The <see cref="T:Infragistics.Controls.Editors.PropertyGridPropertyItem" /> that represents the property whose value is passed in the 'forObject' parameter, or null if the 'forObject' parameter represents a root object instance.  This parameter should be supplied when requesting property generation for a sub-object.</param>
        /// <returns>
        /// A list of <see cref="T:Infragistics.Controls.Editors.PropertyGridPropertyItem" />s.
        /// </returns>
        /// <seealso cref="T:Infragistics.Controls.Editors.PropertyGridPropertyItem" />
        /// <seealso cref="T:Infragistics.Controls.Editors.PropertyGenerationOptions" />
        /// <seealso cref="P:Infragistics.Controls.Editors.PropertyGeneratorBase.GeneratedPropertyFilter" />
        public override List<PropertyGridPropertyItem> GenerateProperties(object forObject, PropertyGenerationOptions generationOptions,
            PropertyGridPropertyItem forPropertyItem)
        {
            var col = base.GenerateProperties(forObject, generationOptions, forPropertyItem);

            /*var col = new List<PropertyGridPropertyItem>();
            foreach (var property in ((ListGenericViewModel)forObject).Properties)
            {
                var collection = base.GenerateProperties(property, generationOptions, forPropertyItem);

                foreach (var p in collection)
                {
                    //var pd = _propertyDescriptor.GetValue(p) as System.ComponentModel.PropertyDescriptor;
                    //var instance = ((ICustomTypeDescriptor)forObject).GetPropertyOwner(pd);
                    col.Add(p);
                }
            }*/
            

            /*foreach (var p in collection)
            {
                var pd = _propertyDescriptor.GetValue(p) as System.ComponentModel.PropertyDescriptor;
                var instance = ((ICustomTypeDescriptor)forObject).GetPropertyOwner(pd);
                //_sourceObject.SetValue(p, instance);
               // _propertyName.SetValue(p, pd.DisplayName); 
                // p.CanResetValue = true;
            }*/

            return col;
        }
    }
}
