﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using PropertyGrid.PropertyDescriptor;
using PropertyGrid.Source;
using PropertyGrid.ViewModel.PropertyInspector;

namespace PropertyGrid.ViewModel
{
    public class ListGenericViewModel: CustomTypeDescriptorViewModel
    {
        private PropertyDescriptorCollection propertyDescriptorCollection;

        private List<ParameterViewModel> properties = new List<ParameterViewModel>();

        public List<ParameterViewModel> Properties
        {
            get { return properties; }
            set
            {
                properties = value;
                OnPropertyChanged();
            }
        }

        public ListGenericViewModel(string prefix)
        {
            Properties.Add(new ParameterViewModel(prefix) { Value = prefix, Name = "First Name", Category = "Personal Data"});
            Properties.Add(new ParameterViewModel("García") { Value = "García", Name = "Last Name", Category = "Personal Data" });
        }

        public override PropertyDescriptorCollection GetProperties()
        {
            var propertyDescriptionCollection = new PropertyDescriptorCollection(null);
            foreach (var property in Properties)
            {
                propertyDescriptionCollection.Add(new ParameterPropertyDescriptor(property));
            }

            return propertyDescriptionCollection;
        }



        public override object GetPropertyOwner(System.ComponentModel.PropertyDescriptor pd)
        {
            var owner = pd as ParameterPropertyDescriptor;
            
            return (owner != null) ? owner.model.Value : null;
        }
    }
}
